import { Config } from './index';
export declare const defaults: {
    fps: number;
    spectrumWidth: string;
    spectrumHeight: string;
    spectrumX: string;
    spectrumY: string;
    spectrumRotation: string;
    spectrumBusesCount: number;
    spectrumBusMargin: number;
    spectrumOpacity: string;
};
export declare const rotationAliasValues: readonly ["up", "down"];
export declare const checkIsPercentValue: (value: string) => boolean;
export declare const getAudioFilePath: (config: Config) => string;
export declare const getBackgroundImagePath: (config: Config) => string;
export declare const getOutVideoPath: (config: Config) => string;
export declare const getFPS: (config: Config) => number;
export declare const getSpectrumBusesCount: () => number;
export declare const getSpectrumBusMargin: () => number;
export declare const getSpectrumWidthAbsolute: (config: Config, backgroundImageWidth: number) => number;
export declare const getSpectrumHeightAbsolute: (config: Config, backgroundImageHeight: number) => number;
export declare const getSpectrumXAbsolute: (config: Config, spectrumWidth: number, backgroundImageWidth: number) => number;
export declare const getSpectrumYAbsolute: (config: Config, spectrumHeight: number, backgroundImageHeight: number) => number;
export declare const checkIsValidRotationAlias: (aliasName: string) => boolean;
export declare const getSpectrumRotation: (config: Config) => "up" | "down";
export declare const getSpectrumColor: (config: Config) => string | import("./image").Color | undefined;
export declare const getSpectrumOpacity: (config: Config) => string;
export declare const getSpectrumOpacityParsed: (config: Config) => number;
export declare const getFfmpeg_cfr: (config: Config) => string | undefined;
export declare const getFfmpeg_preset: (config: Config) => string | undefined;
export declare const getFrame_processing_delay: (config: Config) => number | undefined;
