"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var spectrum_1 = require("./spectrum");
exports.brutForceFFTSignalLength = function (PCMDataLength) {
    var exponent = 1;
    while (true) {
        var pow = Math.pow(2, exponent);
        if ((pow * 2) > PCMDataLength) {
            return Math.pow(2, exponent - 1) * 2;
        }
        exponent++;
    }
};
exports.getSpectrum = function (PCMData) {
    var signalLength = exports.brutForceFFTSignalLength(PCMData.length);
    var signalStartIndex = Math.trunc(PCMData.length / 2 - signalLength / 2);
    var signal = PCMData.slice(signalStartIndex, signalStartIndex + signalLength);
    var spectrumAnalyzer = spectrum_1.createSpectrumAnalyzer(signalLength);
    var spectrum = spectrumAnalyzer(signal);
    for (var i = 0; i < spectrum.length; i++) {
        // attenuates low freqs and boosts highs
        spectrum[i] *= -1 * Math.log((signalLength / 2 - i) * (0.5 / signalLength / 2)) * signalLength;
    }
    return spectrum;
};
//# sourceMappingURL=dsp.js.map