/// <reference types="node" />
import { RotationAliasName } from './index';
import { BmpDecoder } from 'bmp-js';
import { EncodedBmp } from './bpmEncoder';
export interface Color {
    red: number;
    green: number;
    blue: number;
}
interface Position {
    x: number;
    y: number;
}
interface Size {
    width: number;
    height: number;
}
interface MixColorProps {
    color: Color;
    colorOpacity: number;
    backgroundColor: Color;
}
export declare const mixValues: (value1: number, value1Opacity: number, value2: number) => number;
export declare const mixColors: ({ color, colorOpacity, backgroundColor, }: MixColorProps) => Color;
interface DrawRectPorps {
    imageDstBuffer: EncodedBmp;
    position: Position;
    size: Size;
    color: Color;
    opacity: number;
}
export declare const drawRect: ({ imageDstBuffer, position, size, color, opacity, }: DrawRectPorps) => void;
interface CreateVisualizerFrameProps {
    backgroundImageBuffer: EncodedBmp;
    spectrum: number[];
    size: Size;
    position: Position;
    rotation: RotationAliasName;
    margin: number;
    color: Color | string;
    opacity: number;
}
export declare const createVisualizerFrame: ({ backgroundImageBuffer, spectrum, size, position, rotation, margin, color, opacity, }: CreateVisualizerFrameProps) => EncodedBmp;
export declare const convertToBmp: (filePath: string) => Promise<Buffer>;
export declare const parseImage: (buffer: Buffer) => BmpDecoder;
export declare const getImageColor: (image: BmpDecoder) => Color;
export declare const invertColor: (color: Color) => {
    red: number;
    green: number;
    blue: number;
};
export {};
