/// <reference types="node" />
import { rotationAliasValues } from './config';
import { Color } from './image';
export declare const PCM_FORMAT: {
    bit: number;
    sign: string;
    parseFunction: (buffer: Buffer, start: number, end: number) => number[];
};
export interface Config {
    audio: {
        path: string;
    };
    image: {
        path: string;
    };
    outVideo: {
        path: string;
        fps?: number;
        spectrum?: {
            width?: SpectrumSizeValue;
            height?: SpectrumSizeValue;
            x?: number | PositionAliasName;
            y?: number | PositionAliasName;
            rotation?: RotationAliasName;
            color?: Color | string;
            opacity?: string;
        };
    };
    tweaks?: {
        ffmpeg_cfr?: string;
        ffmpeg_preset?: string;
        frame_processing_delay?: number;
    };
}
export declare type SpectrumSizeValue = number | string;
export declare type PositionAliasName = 'left' | 'center' | 'right' | 'top' | 'middle' | 'bottom';
export declare type RotationAliasName = typeof rotationAliasValues[number];
export declare const renderAudioVisualizer: (config: Config, onProgress?: ((progress: number) => any) | undefined, shouldStop?: (() => boolean) | undefined) => Promise<number>;
